
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ProductsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        sku: data.sku
        ||
        null
            ,
            
        barcode: data.barcode
        ||
        null
            ,
            
        short_description: data.short_description
        ||
        null
            ,
            
        product_type: data.product_type
        ||
        null
            ,
            
        is_taxable: data.is_taxable
        ||
        false
        
            ,
            
        vat_rate: data.vat_rate
        ||
        null
            ,
            
        cost_price: data.cost_price
        ||
        null
            ,
            
        selling_price: data.selling_price
        ||
        null
            ,
            
        reorder_level: data.reorder_level
        ||
        null
            ,
            
        track_inventory: data.track_inventory
        ||
        false
        
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await products.setBrand( data.brand || null, {
            transaction,
        });
        
        await products.setCategory( data.category || null, {
            transaction,
        });
        
        await products.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'images',
                belongsToId: products.id,
            },
            data.images,
            options,
        );
        

        return products;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const productsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                sku: item.sku
            ||
            null
            ,
            
                barcode: item.barcode
            ||
            null
            ,
            
                short_description: item.short_description
            ||
            null
            ,
            
                product_type: item.product_type
            ||
            null
            ,
            
                is_taxable: item.is_taxable
            ||
            false
        
            ,
            
                vat_rate: item.vat_rate
            ||
            null
            ,
            
                cost_price: item.cost_price
            ||
            null
            ,
            
                selling_price: item.selling_price
            ||
            null
            ,
            
                reorder_level: item.reorder_level
            ||
            null
            ,
            
                track_inventory: item.track_inventory
            ||
            false
        
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const products = await db.products.bulkCreate(productsData, { transaction });

        // For each item created, replace relation files
        
        for (let i = 0; i < products.length; i++) {
            await FileDBApi.replaceRelationFiles(
                {
                    belongsTo: db.products.getTableName(),
                    belongsToColumn: 'images',
                    belongsToId: products[i].id,
                },
                data[i].images,
                options,
            );
        }
        

        return products;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const products = await db.products.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.sku !== undefined) updatePayload.sku = data.sku;
        
        
        if (data.barcode !== undefined) updatePayload.barcode = data.barcode;
        
        
        if (data.short_description !== undefined) updatePayload.short_description = data.short_description;
        
        
        if (data.product_type !== undefined) updatePayload.product_type = data.product_type;
        
        
        if (data.is_taxable !== undefined) updatePayload.is_taxable = data.is_taxable;
        
        
        if (data.vat_rate !== undefined) updatePayload.vat_rate = data.vat_rate;
        
        
        if (data.cost_price !== undefined) updatePayload.cost_price = data.cost_price;
        
        
        if (data.selling_price !== undefined) updatePayload.selling_price = data.selling_price;
        
        
        if (data.reorder_level !== undefined) updatePayload.reorder_level = data.reorder_level;
        
        
        if (data.track_inventory !== undefined) updatePayload.track_inventory = data.track_inventory;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await products.update(updatePayload, {transaction});

        
        
        if (data.brand !== undefined) {
            await products.setBrand(
              
              data.brand,
              
              { transaction }
            );
        }
        
        if (data.category !== undefined) {
            await products.setCategory(
              
              data.category,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await products.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        
        await FileDBApi.replaceRelationFiles(
            {
                belongsTo: db.products.getTableName(),
                belongsToColumn: 'images',
                belongsToId: products.id,
            },
            data.images,
            options,
        );
        

        return products;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of products) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of products) {
                await record.destroy({transaction});
            }
        });


        return products;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findByPk(id, options);

        await products.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await products.destroy({
            transaction
        });

        return products;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const products = await db.products.findOne(
            { where },
            { transaction },
        );

        if (!products) {
            return products;
        }

        const output = products.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        output.price_list_items_product = await products.getPrice_list_items_product({
            transaction
        });
        
        
        
        
        
        
        output.sale_items_product = await products.getSale_items_product({
            transaction
        });
        
        
        
        
        output.return_items_product = await products.getReturn_items_product({
            transaction
        });
        
        
        
        
        output.purchase_order_items_product = await products.getPurchase_order_items_product({
            transaction
        });
        
        
        output.inventory_items_product = await products.getInventory_items_product({
            transaction
        });
        
        
        output.stock_movements_product = await products.getStock_movements_product({
            transaction
        });
        
        
        
        output.stock_transfer_items_product = await products.getStock_transfer_items_product({
            transaction
        });
        
        
        
        output.images = await products.getImages({
            transaction
        });
        
        
        output.brand = await products.getBrand({
            transaction
        });
        
        
        output.category = await products.getCategory({
            transaction
        });
        
        
        output.organizations = await products.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.brands,
        as: 'brand',
        
        where: filter.brand ? {
          [Op.or]: [
            { id: { [Op.in]: filter.brand.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.brand.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.categories,
        as: 'category',
        
        where: filter.category ? {
          [Op.or]: [
            { id: { [Op.in]: filter.category.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.category.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



      {
        model: db.file,
        as: 'images',
      },

    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.sku) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'sku',
                        filter.sku,
                    ),
                };
            }
            
            if (filter.barcode) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'barcode',
                        filter.barcode,
                    ),
                };
            }
            
            if (filter.short_description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'products',
                        'short_description',
                        filter.short_description,
                    ),
                };
            }
            

            
            

            
            if (filter.vat_rateRange) {
                const [start, end] = filter.vat_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    vat_rate: {
                    ...where.vat_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    vat_rate: {
                    ...where.vat_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.cost_priceRange) {
                const [start, end] = filter.cost_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    cost_price: {
                    ...where.cost_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    cost_price: {
                    ...where.cost_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.selling_priceRange) {
                const [start, end] = filter.selling_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    selling_price: {
                    ...where.selling_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    selling_price: {
                    ...where.selling_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.reorder_levelRange) {
                const [start, end] = filter.reorder_levelRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    reorder_level: {
                    ...where.reorder_level,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    reorder_level: {
                    ...where.reorder_level,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.product_type) {
                where = {
                    ...where,
                product_type: filter.product_type,
            };
            }
            
            if (filter.is_taxable) {
                where = {
                    ...where,
                is_taxable: filter.is_taxable,
            };
            }
            
            if (filter.track_inventory) {
                where = {
                    ...where,
                track_inventory: filter.track_inventory,
            };
            }
            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.products.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'products',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.products.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

